﻿using System;
using System.ComponentModel;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.Printing;
using Infragistics.Win.UltraWinGrid;

namespace TestApp
{
	public partial class Form1 : Form
	{
		public MyContainerList _theList = new MyContainerList();

		public MyContainerList TheList { get { return _theList; } }

		public Form1()
		{
			InitializeComponent();

			_theList.Add(new MyContainer() { Name = "name 1", Address = "address 1", Address2 = "2address 1", State = "state 1" });
			_theList.Add(new MyContainer() { Name = "BUGS Be Here 2", Address = "address 2", Address2 = "2address 2", State = "state 2" });
			_theList.Add(new MyContainer() { Name = "name 3", Address = "BUGS Be Here 3", Address2 = "2address 3", State = "state 3" });
			_theList.Add(new MyContainer() { Name = "name 4", Address = "address 4", Address2 = "BUGS Be Here 4", State = "state 4" });
			_theList.Add(new MyContainer() { Name = "name 5", Address = "address 5", Address2 = "2address 5", State = "state 5" });
			_theList.Add(new MyContainer() { Name = "name 6", Address = "BUGS Be Here 6", Address2 = "2address 6", State = "state 6" });

			ultraGrid1.DataSource = TheList;

			ultraGrid1.DisplayLayout.Bands[0].UseRowLayout = true;
			ultraGrid1.DisplayLayout.Bands[0].Columns[3].RowLayoutColumnInfo.AllowCellSizing = RowLayoutSizing.None;
			ultraGrid1.DisplayLayout.Bands[0].Columns[0].RowLayoutColumnInfo.AllowCellSizing = RowLayoutSizing.None;

			ultraGrid1.DisplayLayout.Bands[0].Columns[0].RowLayoutColumnInfo.Column.Width = 25;
			ultraGrid1.DisplayLayout.Bands[0].Columns[3].RowLayoutColumnInfo.Column.Width = 15;

			// Need this to ensure that the sizing during printing honors fixed columns.
			ultraGrid1.DisplayLayout.Bands[0].Columns[1].RowLayoutColumnInfo.WeightX = 999;
			ultraGrid1.DisplayLayout.Bands[0].Columns[2].RowLayoutColumnInfo.WeightX = 999;

			ultraGrid1.DisplayLayout.AutoFitStyle = Infragistics.Win.UltraWinGrid.AutoFitStyle.ResizeAllColumns;
		}


		private void button1_Click(object sender, EventArgs e)
		{
			using (UltraPrintPreviewDialog previewDialog = new UltraPrintPreviewDialog())
			using (UltraGridPrintDocument printDocument = new UltraGridPrintDocument())
			{
				DateTime localTime = DateTime.Now.ToLocalTime();

				printDocument.Grid = ultraGrid1;
				previewDialog.Document = printDocument;

				printDocument.Header.BorderStyle = UIElementBorderStyle.None;
				printDocument.Header.Height = 25;
				printDocument.Header.Appearance.FontData.SizeInPoints = 8;
				printDocument.Header.TextLeft = "ProductNameHere";
				printDocument.Header.TextRight = string.Format("{0} {1}", localTime.ToShortDateString(), localTime.ToShortTimeString());

				// Use <#> token in the string to designate page numbers.
				printDocument.Footer.TextCenter = "\r\nPage <#>";
				printDocument.Footer.Appearance.FontData.SizeInPoints = 8;
				printDocument.Footer.BorderStyle = UIElementBorderStyle.None;

				previewDialog.Load += new EventHandler(previewDialog_Load);

				previewDialog.ShowDialog(this);
			}
		}

		void previewDialog_Load(object sender, EventArgs e)
		{
			UltraPrintPreviewDialog previewDialog = sender as UltraPrintPreviewDialog;
			if (previewDialog != null)
			{
				previewDialog.Top = this.Top;
				previewDialog.Left = this.Left;
				previewDialog.Width = this.Width;
				previewDialog.Height = this.Height;
			}
		}

		private void ultraGrid1_InitializePrint(object sender, CancelablePrintEventArgs e)
		{
			// Horizontally fit everything in a single page.
			e.DefaultLogicalPageLayoutInfo.FitWidthToPages = 1;

			// Set up the header and the footer.
			e.DefaultLogicalPageLayoutInfo.PageHeader = "My Report Title Here";
			e.DefaultLogicalPageLayoutInfo.PageHeaderHeight = 40;
			e.DefaultLogicalPageLayoutInfo.PageHeaderAppearance.FontData.SizeInPoints = 14;
			e.DefaultLogicalPageLayoutInfo.PageHeaderAppearance.FontData.Bold = DefaultableBoolean.True;
			e.DefaultLogicalPageLayoutInfo.PageHeaderAppearance.TextHAlign = HAlign.Center;
			e.DefaultLogicalPageLayoutInfo.PageHeaderBorderStyle = UIElementBorderStyle.None;

			// Indicate that there is no border on the body of the document.
			e.PrintLayout.BorderStyle = UIElementBorderStyle.None;

			// Set the document name through the PrintDocument which returns a PrintDocument object.
			e.PrintDocument.DocumentName = "Document Title Here";	// name of document used in print queue...
		}
	}

	public class MyContainer
	{
		public string Name { get; set; }
		public string Address { get; set; }
		public string Address2 { get; set; }
		public string State { get; set; }
	}

	public class MyContainerList : BindingList<MyContainer>
	{
	}
}
